@echo off

net session >nul 2>&1
IF %errorLevel% == 0 GOTO BEGIN
echo.
echo.
echo Administrative permissions required. 
echo Current permissions inadequate.
echo.
pause
GOTO EXIT

:BEGIN
cd %~dp0
IF "%PROCESSOR_ARCHITECTURE%"=="x86" (set BIT=x86) ELSE (set BIT=x64)

rem ##########  ##########  ##########  ##########  ##########  ##########  ##########  ##########

:CHECKZIP
set ZIPPATH=
IF "%BIT%" == "x86" GOTO ZIPPC32BIT

:ZIPPC64BIT
FOR /F "tokens=2*" %%A IN ('REG.exe query "HKLM\SOFTWARE\7-Zip" /v "Path" /reg:64 2^>nul') DO set ZIPPATH=%%B 
IF DEFINED ZIPPATH GOTO ZIPINSTALLED

FOR /F "tokens=2*" %%A IN ('REG.exe query "HKLM\SOFTWARE\7-Zip" /v "Path" /reg:32 2^>nul') DO set ZIPPATH=%%B
IF DEFINED ZIPPATH GOTO ZIPINSTALLED
GOTO ZIPNOTINSTALLED

:ZIPPC32BIT
FOR /F "tokens=2*" %%A IN ('REG.exe query "HKLM\SOFTWARE\7-Zip" /v "Path" 2^>nul') DO set ZIPPATH=%%B
IF DEFINED ZIPPATH GOTO ZIPINSTALLED
GOTO ZIPNOTINSTALLED

:ZIPNOTINSTALLED
cls
for /l %%N in (1 1 30) do ( echo.)
echo  7-Zip not found on this PC.
echo  [If you keep looping to this screen you have no real administrator rights.]
echo  [You can check this by starting regedit.exe,                              ]
echo  [if you get an error you are no real administrator.                       ]
echo.
echo  1. Automatic install
echo  2. Manual    install
echo  3. Exit
echo.
echo  (Default is Automatic install, timeout = 30 sec)

CHOICE /C:123 /D:1 /T:30 /M " Enter your choice "
IF ERRORLEVEL 3 GOTO :END
IF ERRORLEVEL 2 GOTO :ZIPMANUALINSTALL
IF ERRORLEVEL 1 GOTO :ZIPAUTOMATICINSTALL

:ZIPMANUALINSTALL
echo.
echo Installing 7-Zip %BIT%. Please wait, this may take a few minutes. 
IF "%BIT%" == "x86" ("%~dp0\7zip\7z938.exe") ELSE ("%~dp0\7zip\7z938-x64.msi")
if errorlevel 1 goto :MYSQLFAILED
GOTO CHECKZIP

:ZIPAUTOMATICINSTALL
call :CHECKFREESPACE 5
echo.
echo Installing 7-Zip %BIT%. Please wait, this may take a few minutes. 
IF "%BIT%" == "x86" ("%~dp0\7zip\7z938.exe" /S) ELSE ("%~dp0\7zip\7z938-x64.msi" /q /passive /norestart)
if errorlevel 1 goto :MYSQLFAILED
GOTO CHECKZIP

:ZIPINSTALLED
call :TRIM ZIPPATH
echo "FOUND : [%ZIPPATH%]"

GOTO :CHECKDOTNET

rem ##########  ##########  ##########  ##########  ##########  ##########  ##########  ##########
REM ## remove spaces at the beginneing and end of a variable

:TRIM
Call :TRIMSUB %%%1%%
set %1=%temp%
GOTO :EOF

:TRIMSUB
set temp=%*
GOTO :EOF

rem ##########  ##########  ##########  ##########  ##########  ##########  ##########  ##########

:CHECKDOTNET
set VSREDISTPATH=
IF "%BIT%" == "x86" GOTO DOTNETPC32BIT

:DOTNETPC64BIT
FOR /F "tokens=2*" %%A IN ('REG.exe query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NET Framework Setup\NDP\v4\Full" /v "Release" /reg:64 2^>nul') DO set DOTNETPATH=%%B
IF NOT DEFINED DOTNETPATH GOTO DOTNETNOTINSTALLED
IF %DOTNETPATH% GEQ 379893 GOTO DOTNETINSTALLED
GOTO DOTNETNOTINSTALLED

:DOTNETPC32BIT
FOR /F "tokens=2*" %%A IN ('REG.exe query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NET Framework Setup\NDP\v4\Full" /v "Release" 2^>nul') DO set DOTNETPATH=%%B
IF NOT DEFINED DOTNETPATH GOTO DOTNETNOTINSTALLED
IF %DOTNETPATH% GEQ 379893 GOTO DOTNETINSTALLED
GOTO DOTNETNOTINSTALLED

:DOTNETNOTINSTALLED
for /l %%N in (1 1 30) do ( echo.)
echo  DOT NET v4.5.2 not found on this PC.
echo.
echo  1. Automatic install
echo  2. Manual    install
echo  3. Exit
echo.
echo  (Default is Automatic install, timeout = 30 sec)

CHOICE /C:123 /D:1 /T:30 /M " Enter your choice "
IF ERRORLEVEL 3 GOTO :END
IF ERRORLEVEL 2 GOTO :DOTNETMANUALINSTALL
IF ERRORLEVEL 1 GOTO :DOTNETAUTOMATICINSTALL

:DOTNETMANUALINSTALL
echo.
echo Installing DOT NET v4.5.2. Please wait, this may take a few minutes. 
"%~dp0\dot_net_452\NDP452-KB2901907-x86-x64-AllOS-ENU.exe"
IF %ERRORLEVEL% == 3010 ( cscript "%~dp0\rebootAfterDotNet.vbs" )
IF %ERRORLEVEL% == 5100 ( cscript "%~dp0\rebootAfterDotNet.vbs" )
if errorlevel 1 goto :MYSQLFAILED
GOTO CHECKDOTNET

:DOTNETAUTOMATICINSTALL
call :CHECKFREESPACE 40
echo.
echo Installing DOT NET v4.5.2. Please wait, this may take a few minutes. 
"%~dp0\dot_net_452\NDP452-KB2901907-x86-x64-AllOS-ENU.exe" /passive /norestart
IF %ERRORLEVEL% == 3010 ( cscript "%~dp0\rebootAfterDotNet.vbs" )
IF %ERRORLEVEL% == 5100 ( cscript "%~dp0\rebootAfterDotNet.vbs" )
if errorlevel 1 goto :MYSQLFAILED
GOTO CHECKDOTNET

:DOTNETINSTALLED
echo "FOUND : DOT NET v4.5.2"

rem ##########  ##########  ##########  ##########  ##########  ##########  ##########  ##########

:CHECKVSREDISTX86
set VSREDISTPATHX86=
IF "%BIT%" == "x86" GOTO :VSREDISTPC32BITX86

:VSREDISTPC64BITX86
FOR /F "tokens=2*" %%A IN ('REG.exe query "HKLM\SOFTWARE\Microsoft\DevDiv\VC\Servicing\12.0\RuntimeMinimum" /v "Install" /reg:32 2^>nul') DO set VSREDISTPATHX86=%%B 
IF DEFINED VSREDISTPATHX86 GOTO :VSINSTALLEDX86
GOTO VSREDISTNOTINSTALLEDX86

:VSREDISTPC32BITX86
FOR /F "tokens=2*" %%A IN ('REG.exe query "HKLM\SOFTWARE\Microsoft\DevDiv\VC\Servicing\12.0\RuntimeMinimum" /v "Install" 2^>nul') DO set VSREDISTPATHX86=%%B
echo %VSREDISTPATHX86% 
IF DEFINED VSREDISTPATHX86 GOTO :VSINSTALLEDX86
GOTO VSREDISTNOTINSTALLEDX86

:VSREDISTNOTINSTALLEDX86
for /l %%N in (1 1 30) do ( echo.)
echo  Visual C++ 2013 x86 (32bit) Redistributable Package not found on this PC.
echo.
echo  1. Automatic install
echo  2. Manual    install
echo  3. Exit
echo.
echo  (Default is Automatic install, timeout = 30 sec)

CHOICE /C:123 /D:1 /T:30 /M " Enter your choice "
IF ERRORLEVEL 3 GOTO :END
IF ERRORLEVEL 2 GOTO :VSREDISTMANUALINSTALLX86
IF ERRORLEVEL 1 GOTO :VSREDISTAUTOMATICINSTALLX86

:VSREDISTMANUALINSTALLX86
echo.
echo Installing Visual C++ 2013 x86 (32bit) Redistributable Package. Please wait, this may take a few minutes. 
"%~dp0\vsredist2013\vcredist_x86.exe"
if errorlevel 1 goto :MYSQLFAILED
GOTO CHECKVSREDISTX86

:VSREDISTAUTOMATICINSTALLX86
call :CHECKFREESPACE 25
echo.
echo Installing Visual C++ 2013 x86 (32bit) Redistributable Package. Please wait, this may take a few minutes. 
"%~dp0\vsredist2013\vcredist_x86.exe" /passive /norestartS
if errorlevel 1 goto :MYSQLFAILED
GOTO CHECKVSREDISTX86

:VSINSTALLEDX86
echo "FOUND : Visual C++ 2013 x86 (32bit) Redistributable Package"

rem ##########  ##########  ##########  ##########  ##########  ##########  ##########  ##########
:CHECKVSREDIST
set VSREDISTPATH=
IF "%BIT%" == "x86" GOTO CHECKMYSQLINSTALLER

:VSREDISTPC64BIT
FOR /F "tokens=2*" %%A IN ('REG.exe query "HKLM\SOFTWARE\Microsoft\DevDiv\VC\Servicing\12.0\RuntimeMinimum" /v "Install" /reg:64 2^>nul') DO set VSREDISTPATH=%%B 
IF DEFINED VSREDISTPATH GOTO VSREDISTINSTALLED
GOTO VSREDISTNOTINSTALLED

:VSREDISTNOTINSTALLED
for /l %%N in (1 1 30) do ( echo.)
echo  Visual C++ 2013 amd64 (64bit) Redistributable Package not found on this PC.
echo.
echo  1. Automatic install
echo  2. Manual    install
echo  3. Exit
echo.
echo  (Default is Automatic install, timeout = 30 sec)

CHOICE /C:123 /D:1 /T:30 /M " Enter your choice "
IF ERRORLEVEL 3 GOTO :END
IF ERRORLEVEL 2 GOTO :VSREDISTMANUALINSTALL
IF ERRORLEVEL 1 GOTO :VSREDISTAUTOMATICINSTALL

:VSREDISTMANUALINSTALL
echo.
echo Installing Visual C++ 2013 amd64 (64bit) Redistributable Package. Please wait, this may take a few minutes. 
"%~dp0\vsredist2013\vcredist_x64.exe"
if errorlevel 1 goto :MYSQLFAILED
GOTO CHECKVSREDIST

:VSREDISTAUTOMATICINSTALL
call :CHECKFREESPACE 25
echo.
echo Installing Visual C++ 2013 amd64 (64bit) Redistributable Package. Please wait, this may take a few minutes. 
"%~dp0\vsredist2013\vcredist_x64.exe" /passive /norestart
if errorlevel 1 goto :MYSQLFAILED
GOTO CHECKVSREDIST

:VSREDISTINSTALLED
echo "FOUND : Visual C++ 2013 amd64 (64bit) Redistributable Package"

rem ##########  ##########  ##########  ##########  ##########  ##########  ##########  ##########

:CHECKMYSQLINSTALLER
set MYSQLINSTALLERPATH=
IF "%BIT%" == "x86" GOTO MYSQLINSTALLERPC32BIT

:MYSQLINSTALLERPC64BIT
FOR /F "tokens=2*" %%A IN ('REG.exe query "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\MySQL\MySQL Installer - Community" /v "installed" /reg:32 2^>nul') DO set MYSQLINSTALLERPATH=%%B 
IF DEFINED MYSQLINSTALLERPATH GOTO MYSQLINSTALLERINSTALLED
GOTO MYSQLINSTALLERNOTINSTALLED

:MYSQLINSTALLERPC32BIT
FOR /F "tokens=2*" %%A IN ('REG.exe query "HKEY_LOCAL_MACHINE\SOFTWARE\MySQL\MySQL Installer - Community" /v "installed" 2^>nul') DO set MYSQLINSTALLERPATH=%%B
IF DEFINED MYSQLINSTALLERPATH GOTO MYSQLINSTALLERINSTALLED
GOTO MYSQLINSTALLERNOTINSTALLED

:MYSQLINSTALLERNOTINSTALLED
for /l %%N in (1 1 30) do ( echo.)
echo  MySQL Installer - Community not found on this PC.

IF NOT EXIST "%~dp0\mysql\mysql-installer-community-5.6.23.0.msi" GOTO MYSQLMISSING

REM echo.
REM echo  1. Automatic install
REM echo  2. Manual    install
REM echo  3. Exit
REM echo.
REM echo  (Default is Automatic install, timeout = 30 sec)
REM 
REM CHOICE /C:123 /D:1 /T:30 /M " Enter your choice "
REM IF ERRORLEVEL 3 GOTO :END
REM IF ERRORLEVEL 2 GOTO :MYSQLINSTALLERMANUALINSTALL
REM IF ERRORLEVEL 1 GOTO :MYSQLINSTALLERAUTOMATICINSTALL
REM 
REM :MYSQLINSTALLERMANUALINSTALL
REM echo.
REM echo Installing MySQL Installer Community. Please wait, this may take a few minutes. 
REM mysql\mysql-installer-community-5.6.23.0.msi
REM "%ZIPPATH%\7z.exe" x "c:\ProgramData\MySQL\MySQL Installer for Windows\NewManifest.zip" -o"C:\ProgramData\MySQL\MySQL Installer for Windows\Manifest"
REM GOTO CHECKMYSQLINSTALLER

:MYSQLINSTALLERAUTOMATICINSTALL
call :CHECKFREESPACE 850
echo.
echo Installing MySQL Installer Community. Please wait, this may take a few minutes. 
"%~dp0\mysql\mysql-installer-community-5.6.23.0.msi" /qn
if errorlevel 1 goto :MYSQLFAILED
echo UNPACKING : c:\ProgramData\MySQL\MySQL Installer for Windows\NewManifest.zip
"%ZIPPATH%\7z.exe" x "c:\ProgramData\MySQL\MySQL Installer for Windows\NewManifest.zip" -o"C:\ProgramData\MySQL\MySQL Installer for Windows\Manifest"
if ERRORLEVEL 1 goto :MYSQLFAILED
GOTO CHECKMYSQLINSTALLER

:MYSQLINSTALLERINSTALLED
echo "FOUND : MySQL Installer - Community"

IF "%BIT%" == "x86" (set MYSQLCONSOLE="C:\Program Files\MySQL\MySQL Installer for Windows\MySQLInstallerConsole.exe") ELSE (set MYSQLCONSOLE="C:\Program Files (x86)\MySQL\MySQL Installer for Windows\MySQLInstallerConsole.exe")

:NETCONNECTORCHECK
%MYSQLCONSOLE% community status | findstr /C:"Connector/NET" > nul
if ERRORLEVEL 1 goto :NETCONNECTORINSTALL
GOTO :SERVERCHECK

:NETCONNECTORINSTALL
echo INSTALL mysql dot net 
%MYSQLCONSOLE% community install net;6.9.5 -silent
if ERRORLEVEL 1 goto :MYSQLFAILED

:SERVERCHECK
set MYSQLSTATUS=
%MYSQLCONSOLE% community status | findstr /C:"MySQL Server" > nul 
if ERRORLEVEL 1 goto :SERVERINSTALL
GOTO WORKBENCHCHECK

:SERVERINSTALL
echo.
echo INSTALL mysql server 
%MYSQLCONSOLE% community install server;5.6.23;%BIT%:*:port=3306;passwd=txcare;rootpasswd=txcare;servicename=TXCARE_DBS; -silent
if ERRORLEVEL 1 goto :MYSQLFAILED
set MYSQLSTATUS=install
GOTO WORKBENCHCHECK

:WORKBENCHCHECK
%MYSQLCONSOLE% community status | findstr /C:"MySQL Workbench" > nul
if ERRORLEVEL 1 goto :WORKBENCHINSTALL
GOTO :INSTALLINI

:WORKBENCHINSTALL
echo.
echo INSTALL mysql workbench 
%MYSQLCONSOLE% community install workbench;6.2.4;%BIT% -silent
if ERRORLEVEL 1 goto :MYSQLFAILED
echo.

:INSTALLINI
IF NOT EXIST c:\Txcare\redundancy\txcare.ini GOTO INSTALLINI
FOR /l %%N IN (1 1 30) do ( echo.)
echo  txcare.ini found on this PC.
echo.
echo  1. Overwrite with new version
echo  2. Keep current version
echo.
echo  (Default is Overwrite with new version, timeout = 30 sec)

CHOICE /C:12 /D:1 /T:30 /M " Enter your choice "
IF ERRORLEVEL 2 GOTO :INIINSTALLED
IF ERRORLEVEL 1 GOTO :INSTALLINI

:INSTALLINI
mkdir c:\TXCare\Redundancy
copy /y /v "%~dp0\ini\txcare.ini" c:\Txcare\redundancy

:INIINSTALLED
for /l %%N in (1 1 30) do ( echo.)
if "%MYSQLSTATUS%" == "install" GOTO CONFIGURESERVICE
echo RESET service name to default
%MYSQLCONSOLE% community configure server:port=3306;passwd=txcare;rootpasswd=txcare;servicename=TXCARE_DBS; -silent
if ERRORLEVEL 1 goto :MYSQLFAILED
ping 127.0.0.1 -n 6 > nul

:CONFIGURESERVICE
echo STOP SERVICE 
net stop TXCARE_DBS 
ping 127.0.0.1 -n 3 > nul
TASKKILL /f /im mysqld.exe >nul 2>nul
echo.
echo DELETE SERVICE IF EXISTS
sc delete TXCARE_DBS
echo.
echo CREATE SERVICE
IF EXIST "C:\Program Files\MySQL\MySQL Server 5.6\bin\mysqld.exe" (set MYSQLDPATH="C:\Program Files\MySQL\MySQL Server 5.6\bin\mysqld.exe") ELSE (set MYSQLDPATH="C:\Program Files (x86)\MySQL\MySQL Server 5.6\bin\mysqld.exe")
%MYSQLDPATH% --install TXCARE_DBS --defaults-file=C:\TXCARE\Redundancy\txcare.ini 
if errorlevel 1 goto :MYSQLFAILED
GOTO :STARTSERVICE

:STARTSERVICE
echo.
echo STARTING SERVICE
net start TXCARE_DBS
if errorlevel 1 goto :MYSQLSERVERRESTART
GOTO MYSQLSTARTED

:MYSQLSERVERRESTART
echo.
echo.
echo On slow pc's we need to restart the service because the initial setup
echo of mysql and creation of the databases take more then 30 sec.
ping 127.0.0.1 -n 31 > nul
SC INTERROGATE TXCARE_DBS | FIND "STATE"
echo.
echo STOP SERVICE 
net stop TXCARE_DBS
ping 127.0.0.1 -n 3 > nul
TASKKILL /f /im mysqld.exe >nul 2>nul
echo.
echo STARTING SERVICE
net start TXCARE_DBS
rem if errorlevel 1 goto :MYSQLFAILED

:MYSQLSTARTED
if "%MYSQLSTATUS%" == "install" GOTO PRIVILEGES

:RESETPRIVILEGES
echo SET root passwd to default
echo STOP SERVICE 
net stop TXCARE_DBS
ping 127.0.0.1 -n 3 > nul
TASKKILL /f /im mysqld.exe >nul 2>nul 

IF EXIST "C:\Program Files\MySQL\MySQL Server 5.6\bin\mysqld.exe" (set MYSQLDPATH="C:\Program Files\MySQL\MySQL Server 5.6\bin") ELSE (set MYSQLDPATH="C:\Program Files (x86)\MySQL\MySQL Server 5.6\bin\")
mkdir c:\tmp
copy /y /v "%~dp0\mysql-reset-passwd.ini" c:\tmp
cd %MYSQLDPATH%
start /B "" mysqld.exe --init-file="c:\\tmp\\mysql-reset-passwd.ini" --console --verbose --explicit_defaults_for_timestamp
ping 127.0.0.1 -n 4 > nul 
taskkill /f /im mysqld.exe
start /B "" mysqld.exe --defaults-file="C:\\ProgramData\\MySQL\\MySQL Server 5.6\\my.ini" --init-file="c:\\tmp\\mysql-reset-passwd.ini" --console --verbose --explicit_defaults_for_timestamp
ping 127.0.0.1 -n 4 > nul 
taskkill /f /im mysqld.exe
DEL /F /S /Q /A "c:\tmp\mysql-reset-passwd.ini"
cd %~dp0

echo STARTING SERVICE
net start TXCARE_DBS
if errorlevel 1 goto :MYSQLFAILED
GOTO :MYSQLDONE

:PRIVILEGES
echo Grant privileges
"C:\Program Files\MySQL\MySQL Server 5.6\bin\mysqladmin.exe" -u root -v password txcare >nul 2>nul
if errorlevel 1 goto :MYSQLFAILED
"C:\Program Files\MySQL\MySQL Server 5.6\bin\mysql.exe" --user=root --password=txcare -v --execute="GRANT ALL PRIVILEGES ON *.* TO 'root'@'%%' IDENTIFIED BY 'txcare' WITH GRANT OPTION;" >nul 2>nul
if errorlevel 1 goto :MYSQLFAILED
echo Flush privileges
"C:\Program Files\MySQL\MySQL Server 5.6\bin\mysql.exe" --user=root --password=txcare -v --execute="FLUSH PRIVILEGES;" >nul 2>nul
GOTO :MYSQLDONE

:MYSQLDONE
echo.
schtasks /delete /tn \MySQL\Installer\ManifestUpdate /f >nul 2>nul
echo.

GOTO :END

rem ##########  ##########  ##########  ##########  ##########  ##########  ##########  ##########
REM ## Check free diskspace in MB

:CHECKFREESPACE
set SPACE=
FOR /F %%A IN ('cscript //nologo "%~dp0\checkFreeDiskspaceInMegaBytes.vbs" %1 ') DO set SPACE=%%A 
call :TRIM SPACE
rem echo [%SPACE%]
if NOT "%SPACE%" == "True" ( 
  FOR /l %%N IN (1 1 5) do ( echo.)
  echo "Not enough disk space available. %1 MB of free disk space is required on the C-drive."
  pause
  exit 1
)
GOTO :EOF

rem ##########  ##########  ##########  ##########  ##########  ##########  ##########  ##########

:END
echo.
FOR /l %%N IN (1 1 10) do ( echo.)
echo MySQL installation completed.
echo.
echo.
echo.
GOTO :EXIT

:MYSQLMISSING
FOR /l %%N IN (1 1 30) do ( echo.)
echo !! The MySQL install is missing at 
echo !!  "%~dp0\mysql\mysql-installer-community-5.6.23.0.msi"
echo.
echo Please download 
echo https://dev.mysql.com/get/Downloads/MySQLInstaller/mysql-installer-community-5.6.23.0.msi 
echo and place it at 
echo "%~dp0\mysql\mysql-installer-community-5.6.23.0.msi" 
GOTO :EXIT

:MYSQLFAILED
FOR /l %%N IN (1 1 5) do ( echo.)
echo !! The installation of MySQL or its prerequisits has failed.
GOTO :EXIT

:EXIT
pause
exit
